/*
This is a part of the IconDesk LiteStep module source code.
Copyright (C) 2003 Erik Christiansson, aka Sci
http://www.alphafish.com/
erik@alphafish.com

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
#ifndef __SHELLNOTIFY_H
#define __SHELLNOTIFY_H

#include <windows.h>
#include <shlobj.h>
#include "../lsapi/lsapi.h"
#include "../lsapi/lswinbase.h"
#include "pidl.h"
#include "Group.h"

class Group;

#define WM_APP_SHELLNOTIFY	WM_USER + 3001
#define SHCNF_INTERRUPT		0x0001
#define SHCNF_SHELL			0x0002
#define SHCNF_NO_PROXY		0x8000

class ShellNotify : public Window
{
public:
	ShellNotify(LPITEMIDLIST pidl, Group* pGroup);
	~ShellNotify();

private:
	virtual void windowProc(Message& message);
	void onCreate(Message& message);
	void onDestroy(Message& message);
	void onShellNotify(Message& message);

	void processNotification(LONG wEvent, LPITEMIDLIST pidl1, LPITEMIDLIST pidl2);

	HWND			_hDesktop;
	long			_hNotify;
	Group*			_pGroup;
	LPITEMIDLIST	_pidl;

	typedef struct {
		LPCITEMIDLIST  pidl;
		BOOL           fRecursive;
	} SHChangeNotifyEntry;
	ULONG (WINAPI *SHChangeNotifyRegister)(HWND,int,LONG,UINT,int,SHChangeNotifyEntry*);
	BOOL (WINAPI *SHChangeNotifyDeregister)(ULONG);
	HANDLE (WINAPI *SHChangeNotification_Lock)(HANDLE,DWORD,LPITEMIDLIST**,LONG*);
	BOOL (WINAPI *SHChangeNotification_Unlock)(HANDLE);

};

#endif//__SHELLNOTIFY_H
